#include "w_uimain.h"


static
BOOL    MethodDialogCommand(HWND Dialog, UINT /*Command*/,
                              int ControlId, HWND /*Control*/)
    {
    TProperty   *Property   = (TProperty *)GetWindowLong(Dialog, DWL_USER);
    char Path[256];
    strcpy(Path, Property->Path);
    if(ControlId == IDCANCEL)   // "Done" button
        {
        EndDialog(Dialog, -1);
        return TRUE;
        }
    else if(ControlId == IDOK)  // "Execute" button
        {
        char    Attribute[WUIMAN_MAXNAME+1];
        sprintf(Attribute, "m_%s", Property->Property);
        TCharBuffer Result(1024);
        TCharBuffer Command(1024);
        GetDlgItemText(Dialog, ID_METHDETAIL_EDIT, Command, 1023);
        long    Status = WUIMAN_Get(Property->Path,
                            Command, Result, 1024);
        if(Status < WUIMAN_ERRORS)
            WUIMAN_Error(Status, Result);
        SetDlgItemText(Dialog, ID_METHRESULT_EDIT, Result);
        }
    return FALSE;
    }

BOOL CALLBACK _export WUIMAN_MethodDialog(HWND Dialog,
                 UINT Message, WPARAM Param1, LPARAM Param2)
    {
    TProperty   *Property   = (TProperty *)GetWindowLong(Dialog, DWL_USER);
    switch(Message)
        {
        case    WM_INITDIALOG   :
            {
            SetWindowLong(Dialog, DWL_USER, Param2);
            Property    = (TProperty *)Param2;
            char Path[256];
            strcpy(Path, "m_");
            strcat(Path, Property->Property);
            strcat(Path, "()");
            SetDlgItemText(Dialog, ID_METHDETAIL_EDIT, Property->Property);
            strcpy(Path, Property->Path);
//            if(strlen(Path) > 1)
//                strcat(Path, "/");
//            strcat(Path, ".p_");
//            strcat(Path, Property->Property);
            char ClassName[WUIMAN_MAXNAME];
            WUIGET(Path,
                    "m_Class()", ClassName, WUIMAN_MAXNAME);
            SetDlgItemText(Dialog, ID_CLASS_NAME, ClassName);
            WUIGET(Path,
                    "m_ParentClass()", ClassName, WUIMAN_MAXNAME);
            SetDlgItemText(Dialog, ID_PARENT_NAME, ClassName);
            char    Text[512];
            sprintf(Text, "%s.%s", Property->Path, Property->Property);
            SetDlgItemText(Dialog, IDPROP_PATH_STATIC, Text);
            char    Attribute[128];
            return TRUE;
            }
        case    WM_CTLCOLOR :
            {
            HDC DC = (HDC)Param1;
            SetTextColor(DC, RGB(0,0,0));
            SetBkColor(DC, RGB(198,198,198));
            return (BOOL)GetStockObject(LTGRAY_BRUSH);
            }
        case    WM_COMMAND      :
            return DialogCommand(MethodDialogCommand,
                                    Dialog, Param1, Param2);
        }
    return FALSE;
    }


